%global shortname typescript

# The tests depend on npm packages not yet packaged for Fedora
%global enable_tests 0

Name:           nodejs-typescript
Version:        2.8.3
Release:        2%{?dist}
Summary:        A language for application scale JavaScript development

License:        ASL 2.0
URL:            https://github.com/Microsoft/TypeScript/
Source0:        http://registry.npmjs.org/%{shortname}/-/%{shortname}-%{version}.tgz
# The test files are not included in the npm tarball.
# Source{1-9} are generated by running Source10, which pulls from the upstream
# version control repository.
Source1:	tests-%{version}.tar.bz2
Source2:	src-%{version}.tar.bz2
Source3:	docs-%{version}.tar.bz2
Source4:	scripts-%{version}.tar.bz2
Source10:	dl-tests.sh
# Jakefile for tests
Source11:	https://raw.githubusercontent.com/Microsoft/TypeScript/v%{version}/Jakefile.js

BuildArch:      noarch
ExclusiveArch:  %{nodejs_arches} noarch

BuildRequires:  nodejs-packaging

%if 0%{enable_tests}
BuildRequires:	jake
BuildRequires:	npm(del)
BuildRequires:	npm(travis-fold)	# not yet packaged for Fedora
%endif

%description
TypeScript is a language for application-scale JavaScript. TypeScript
adds optional types, classes, and modules to JavaScript. TypeScript
supports tools for large-scale JavaScript applications for any browser,
for any host, on any OS. TypeScript compiles to readable, standards-based
JavaScript.

%prep
%setup -qn package
# setup the tests, src, docs, scripts
%autosetup -T -D -a 1 -n package
%autosetup -T -D -a 2 -n package
%autosetup -T -D -a 3 -n package
%autosetup -T -D -a 4 -n package
# Jakefile
cp -p %{SOURCE11} .

%build
# Nothing to do

%install
mkdir -p %{buildroot}%{nodejs_sitelib}/%{shortname}/
cp -pr package.json bin/ lib/ %{buildroot}%{nodejs_sitelib}/%{shortname}

# Make tsc executable
chmod +x %{buildroot}%{nodejs_sitelib}/%{shortname}/bin/tsc

# Symlink tsc executable file to _bindir
mkdir -p %{buildroot}%{_bindir}
pushd %{buildroot}%{_bindir}
    ln -s %{nodejs_sitelib}/%{shortname}/bin/tsc
popd

%check
%nodejs_symlink_deps --check
%{__nodejs} -e 'require("./")'
%if 0%{?enable_tests}
%{_bindir}/jake
%else
%{_bindir}/echo -e "\e[101m -=#=- Tests disabled -=#=- \e[0m"
%endif


%files
%{_bindir}/tsc
%{nodejs_sitelib}/%{shortname}
%doc ThirdPartyNoticeText.txt README.md CopyrightNotice.txt
%license LICENSE.txt

%changelog
* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.8.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed May 23 2018 Jared K. Smith <jsmith@fedoraproject.org> - 2.8.3-1
- Update to upstream 2.8.3 release

* Fri Apr 06 2018 Jared K. Smith <jsmith@fedoraproject.org> - 2.8.1-1
- Update to upstream 2.8.1 release

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.1-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat Jan 31 2015 Gerard Ryan <galileo@fedoraproject> - 1.4.1-1
- Initial package
